// bls12-381 bigint addition chain for computing sqrt(U/V)
//
// (C) 2019 anonymous authors. All rights reserved.

#ifndef __bls_hash__src__bint__bint_chains_h__
// clang-format off

/* *** addchain for 1000602388805416848354447456433976039139220704984751971333014534031007912622709466110671907282253916009473568139946 *** */
/* Bos-Coster (win=4) : 458 links, 16 variables */
#define divsqrt_chain(TMPVAR1, TMPVAR0) do { \
        bint_ty TMPVAR2; \
        bint_ty TMPVAR3; \
        bint_ty TMPVAR4; \
        bint_ty TMPVAR5; \
        bint_ty TMPVAR6; \
        bint_ty TMPVAR7; \
        bint_ty TMPVAR8; \
        bint_ty TMPVAR9; \
        bint_ty TMPVAR10; \
        bint_ty TMPVAR11; \
        bint_ty TMPVAR12; \
        bint_ty TMPVAR13; \
        bint_ty TMPVAR14; \
        bint_ty TMPVAR15; \
        bint_sqr(TMPVAR1, TMPVAR0);                                                    /*    0 : 2 */ \
        bint_mul(TMPVAR9, TMPVAR1, TMPVAR0);                                           /*    1 : 3 */ \
        bint_sqr(TMPVAR5, TMPVAR1);                                                    /*    2 : 4 */ \
        bint_mul(TMPVAR2, TMPVAR9, TMPVAR1);                                           /*    3 : 5 */ \
        bint_mul(TMPVAR7, TMPVAR5, TMPVAR9);                                           /*    4 : 7 */ \
        bint_mul(TMPVAR10, TMPVAR2, TMPVAR5);                                          /*    5 : 9 */ \
        bint_mul(TMPVAR13, TMPVAR7, TMPVAR5);                                          /*    6 : 11 */ \
        bint_mul(TMPVAR4, TMPVAR10, TMPVAR5);                                          /*    7 : 13 */ \
        bint_mul(TMPVAR8, TMPVAR13, TMPVAR5);                                          /*    8 : 15 */ \
        bint_mul(TMPVAR15, TMPVAR4, TMPVAR5);                                          /*    9 : 17 */ \
        bint_mul(TMPVAR11, TMPVAR8, TMPVAR5);                                          /*   10 : 19 */ \
        bint_mul(TMPVAR3, TMPVAR15, TMPVAR5);                                          /*   11 : 21 */ \
        bint_mul(TMPVAR12, TMPVAR11, TMPVAR5);                                         /*   12 : 23 */ \
        bint_sqr(TMPVAR1, TMPVAR4);                                                    /*   13 : 26 */ \
        bint_mul(TMPVAR14, TMPVAR12, TMPVAR5);                                         /*   14 : 27 */ \
        bint_mul(TMPVAR6, TMPVAR1, TMPVAR9);                                           /*   15 : 29 */ \
        bint_mul(TMPVAR5, TMPVAR1, TMPVAR2);                                           /*   16 : 31 */ \
        for (int nops = 0; nops < 12; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }          /*   17 : 106496 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR15);                                          /*   29 : 106513 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   30 : 13633664 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR8);                                           /*   37 : 13633679 */ \
        for (int nops = 0; nops < 4; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   38 : 218138864 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR2);                                           /*   42 : 218138869 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   43 : 13960887616 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR7);                                           /*   49 : 13960887623 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   50 : 1786993615744 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR12);                                          /*   57 : 1786993615767 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   58 : 57183795704544 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*   63 : 57183795704575 */ \
        for (int nops = 0; nops < 2; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   64 : 228735182818300 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR9);                                           /*   66 : 228735182818303 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   67 : 14639051700371392 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*   73 : 14639051700371405 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   74 : 936899308823769920 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*   80 : 936899308823769933 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   81 : 59961555764721275712 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR10);                                          /*   87 : 59961555764721275721 */ \
        for (int nops = 0; nops < 3; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   88 : 479692446117770205768 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR9);                                           /*   91 : 479692446117770205771 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*   92 : 61400633103074586338688 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*   99 : 61400633103074586338701 */ \
        for (int nops = 0; nops < 4; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  100 : 982410129649193381419216 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*  104 : 982410129649193381419229 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  105 : 62874248297548376410830656 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR8);                                           /*  111 : 62874248297548376410830671 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  112 : 4023951891043096090293162944 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR14);                                          /*  118 : 4023951891043096090293162971 */ \
        for (int nops = 0; nops < 3; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  119 : 32191615128344768722345303768 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR0);                                           /*  122 : 32191615128344768722345303769 */ \
        for (int nops = 0; nops < 8; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  123 : 8241053472856260792920397764864 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*  131 : 8241053472856260792920397764877 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  132 : 1054854844525601381493810913904256 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR12);                                          /*  139 : 1054854844525601381493810913904279 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  140 : 33755355024819244207801949244936928 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR13);                                          /*  145 : 33755355024819244207801949244936939 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  146 : 2160342721588431629299324751675964096 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*  152 : 2160342721588431629299324751675964109 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  153 : 138261934181659624275156784107261702976 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR6);                                           /*  159 : 138261934181659624275156784107261703005 */ \
        for (int nops = 0; nops < 4; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  160 : 2212190946906553988402508545716187248080 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR10);                                          /*  164 : 2212190946906553988402508545716187248089 */ \
        for (int nops = 0; nops < 8; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  165 : 566320882408077821031042187703343935510784 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR6);                                           /*  173 : 566320882408077821031042187703343935510813 */ \
        for (int nops = 0; nops < 4; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  174 : 9061134118529245136496675003253502968173008 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*  178 : 9061134118529245136496675003253502968173021 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  179 : 1159825167171743377471574400416448379926146688 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR12);                                          /*  186 : 1159825167171743377471574400416448379926146711 */ \
        for (int nops = 0; nops < 9; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  187 : 593830485591932609265446093013221570522187116032 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR11);                                          /*  196 : 593830485591932609265446093013221570522187116051 */ \
        for (int nops = 0; nops < 2; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  197 : 2375321942367730437061784372052886282088748464204 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR9);                                           /*  199 : 2375321942367730437061784372052886282088748464207 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  200 : 76010302155767373985977099905692361026839950854624 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR7);                                           /*  205 : 76010302155767373985977099905692361026839950854631 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  206 : 9729318675938223870205068787928622211435513709392768 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR2);                                           /*  213 : 9729318675938223870205068787928622211435513709392773 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  214 : 1245352790520092655386248804854863643063745754802274944 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR10);                                          /*  221 : 1245352790520092655386248804854863643063745754802274953 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  222 : 79702578593285929944719923510711273156079728307345596992 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR12);                                          /*  228 : 79702578593285929944719923510711273156079728307345597015 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  229 : 2550482514985149758231037552342760740994551305835059104480 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR6);                                           /*  234 : 2550482514985149758231037552342760740994551305835059104509 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  235 : 81615440479524792263393201674968343711825641786721891344288 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR11);                                          /*  240 : 81615440479524792263393201674968343711825641786721891344307 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  241 : 2611694095344793352428582453598986998778420537175100523017824 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR11);                                          /*  246 : 2611694095344793352428582453598986998778420537175100523017843 */ \
        for (int nops = 0; nops < 8; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  247 : 668593688408267098221717108121340671687275657516825733892567808 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*  255 : 668593688408267098221717108121340671687275657516825733892567821 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  256 : 85579992116258188572379789839531605975971284162153693938248681088 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR3);                                           /*  263 : 85579992116258188572379789839531605975971284162153693938248681109 */ \
        for (int nops = 0; nops < 9; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  264 : 43816955963524192549058452397840182259697297491022691296383324727808 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR8);                                           /*  273 : 43816955963524192549058452397840182259697297491022691296383324727823 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  274 : 1402142590832774161569870476730885832310313519712726121484266391290336 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*  279 : 1402142590832774161569870476730885832310313519712726121484266391290349 */ \
        for (int nops = 0; nops < 3; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  280 : 11217140726662193292558963813847086658482508157701808971874131130322792 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR9);                                           /*  283 : 11217140726662193292558963813847086658482508157701808971874131130322795 */ \
        for (int nops = 0; nops < 8; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  284 : 2871588026025521482895094736344854184571522088371663096799777569362635520 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR8);                                           /*  292 : 2871588026025521482895094736344854184571522088371663096799777569362635535 */ \
        for (int nops = 0; nops < 3; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  293 : 22972704208204171863160757890758833476572176706973304774398220554901084280 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR9);                                           /*  296 : 22972704208204171863160757890758833476572176706973304774398220554901084283 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  297 : 2940506138650133998484577010017130685001238618492583011122972231027338788224 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR10);                                          /*  304 : 2940506138650133998484577010017130685001238618492583011122972231027338788233 */ \
        for (int nops = 0; nops < 9; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  305 : 1505539142988868607224103429128770910720634172668202501694961782285997459575296 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR8);                                           /*  314 : 1505539142988868607224103429128770910720634172668202501694961782285997459575311 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  315 : 96354505151287590862342619464241338286120587050764960108477554066303837412819904 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR3);                                           /*  321 : 96354505151287590862342619464241338286120587050764960108477554066303837412819925 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  322 : 6166688329682405815189927645711445650311717571248957446942563460243445594420475200 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  328 : 6166688329682405815189927645711445650311717571248957446942563460243445594420475231 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  329 : 197334026549836986086077684662766260809974962279966638302162030727790259021455207392 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  334 : 197334026549836986086077684662766260809974962279966638302162030727790259021455207423 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  335 : 6314688849594783554754485909208520345919198792958932425669184983289288288686566637536 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  340 : 6314688849594783554754485909208520345919198792958932425669184983289288288686566637567 */ \
        for (int nops = 0; nops < 4; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  341 : 101035021593516536876071774547336325534707180687342918810706959732628612618985066201072 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*  345 : 101035021593516536876071774547336325534707180687342918810706959732628612618985066201085 */ \
        for (int nops = 0; nops < 3; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  346 : 808280172748132295008574196378690604277657445498743350485655677861028900951880529608680 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR9);                                           /*  349 : 808280172748132295008574196378690604277657445498743350485655677861028900951880529608683 */ \
        for (int nops = 0; nops < 8; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  350 : 206919724223521867522194994272944794695080306047678297724327853532423398643681415579822848 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR3);                                           /*  358 : 206919724223521867522194994272944794695080306047678297724327853532423398643681415579822869 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  359 : 26485724700610799042840959266936933720970279174102822108713965252150195026391221194217327232 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  366 : 26485724700610799042840959266936933720970279174102822108713965252150195026391221194217327263 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  367 : 847543190419545569370910696541981879071048933571290307478846888068806240844519078214954472416 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  372 : 847543190419545569370910696541981879071048933571290307478846888068806240844519078214954472447 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  373 : 27121382093425458219869142289343420130273565874281289839323100418201799707024610502878543118304 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  378 : 27121382093425458219869142289343420130273565874281289839323100418201799707024610502878543118335 */ \
        for (int nops = 0; nops < 4; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  379 : 433942113494807331517906276629494722084377053988500637429169606691228795312393768046056689893360 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR8);                                           /*  383 : 433942113494807331517906276629494722084377053988500637429169606691228795312393768046056689893375 */ \
        for (int nops = 0; nops < 4; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  384 : 6943073815916917304286500426071915553350032863816010198866713707059660724998300288736907038294000 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR7);                                           /*  388 : 6943073815916917304286500426071915553350032863816010198866713707059660724998300288736907038294007 */ \
        for (int nops = 0; nops < 7; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  389 : 888713448437365414948672054537205190828804206568449305454939354503636572799782436958324100901632896 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  396 : 888713448437365414948672054537205190828804206568449305454939354503636572799782436958324100901632927 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  397 : 28438830349995693278357505745190566106521734610190377774558059344116370329593037982666371228852253664 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR6);                                           /*  402 : 28438830349995693278357505745190566106521734610190377774558059344116370329593037982666371228852253693 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  403 : 910042571199862184907440183846098115408695507526092088785857899011723850546977215445323879323272118176 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  408 : 910042571199862184907440183846098115408695507526092088785857899011723850546977215445323879323272118207 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  409 : 29121362278395589917038085883075139693078256240834946841147452768375163217503270894250364138344707782624 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  414 : 29121362278395589917038085883075139693078256240834946841147452768375163217503270894250364138344707782655 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  415 : 931883592908658877345218748258404470178504199706718298916718488588005222960104668616011652427030649044960 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  420 : 931883592908658877345218748258404470178504199706718298916718488588005222960104668616011652427030649044991 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  421 : 29820274973077084075046999944268943045712134390614985565334991634816167134723349395712372877664980769439712 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  426 : 29820274973077084075046999944268943045712134390614985565334991634816167134723349395712372877664980769439743 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  427 : 954248799138466690401503998216606177462788300499679538090719732314117348311147180662795932085279384622071776 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  432 : 954248799138466690401503998216606177462788300499679538090719732314117348311147180662795932085279384622071807 */ \
        for (int nops = 0; nops < 5; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  433 : 30535961572430934092848127942931397678809225615989745218903031434051755145956709781209469826728940307906297824 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR5);                                           /*  438 : 30535961572430934092848127942931397678809225615989745218903031434051755145956709781209469826728940307906297855 */ \
        for (int nops = 0; nops < 4; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  439 : 488575385158894945485570047086902362860947609855835923502448502944828082335307356499351517227663044926500765680 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR4);                                           /*  443 : 488575385158894945485570047086902362860947609855835923502448502944828082335307356499351517227663044926500765693 */ \
        for (int nops = 0; nops < 6; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  444 : 31268824650169276511076483013561751223100647030773499104156704188468997269459670815958497102570434875296049004352 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR3);                                           /*  450 : 31268824650169276511076483013561751223100647030773499104156704188468997269459670815958497102570434875296049004373 */ \
        for (int nops = 0; nops < 4; nops++) { bint_sqr(TMPVAR1, TMPVAR1); }           /*  451 : 500301194402708424177223728216988019569610352492375985666507267015503956311354733055335953641126958004736784069968 */ \
        bint_mul(TMPVAR1, TMPVAR1, TMPVAR2);                                           /*  455 : 500301194402708424177223728216988019569610352492375985666507267015503956311354733055335953641126958004736784069973 */ \
        bint_sqr(TMPVAR1, TMPVAR1);                                                    /*  456 : 1000602388805416848354447456433976039139220704984751971333014534031007912622709466110671907282253916009473568139946 */ \
    } while (0)

// clang-format on
#define __bls_hash__src__bint__bint_chains_h__
#endif  // __bls_hash__src__bint__bint_chains_h__
